﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Ohsai_TestProject
{
    [Ohsai.OhsaiAgent("Actor", "provides a actor type.")]
    public class Actor : Ohsai.BasicAgent, IObject
    {
        [Ohsai.OhsaiProperty("FOV", "Gets or sets the actor field of view.")]
        public float FOV { get; set; }
        [Ohsai.OhsaiProperty("ViewDistance", "Gets or sets the actors view distance.")]
        public float ViewDistance { get; set; }
        [Ohsai.OhsaiProperty("CollisionRadius", "Gets or sets the actors collision radius.")]
        public float CollisionRadius
        {
            get { return this.collisionSphere.Radius; }
            set { this.collisionSphere.Radius = value; }
        }

        private BoundingSphere collisionSphere;

        
        public override Vector3 Position
        {
            get
            {
                return base.Position;
            }
            set
            {
                base.Position = value;
                this.collisionSphere.Center = value;
            }
        }

        public bool Intersects(BoundingFrustum view)
        {
            return this.collisionSphere.Intersects(view);
        }

        public bool Intersects(BoundingSphere sphere)
        {
            return this.collisionSphere.Intersects(sphere);
        }
    }
}
