using Microsoft.Xna.Framework;

namespace Ohsai_TestProject
{
    public class BaseObject : IObject
    {
        private BoundingSphere collisionSphere;


        public virtual Vector3 Position
        {
            get { return this.collisionSphere.Center; }
            set { this.collisionSphere.Center = value; }
        }

        public float CollisionRadius
        {
            get { return this.collisionSphere.Radius; }
            set { this.collisionSphere.Radius = value; }
        }

        public virtual bool Intersects(BoundingFrustum view)
        {
            return this.collisionSphere.Intersects(view);
        }

        public virtual bool Intersects(BoundingSphere sphere)
        {
            return this.collisionSphere.Intersects(sphere);
        }
    }
}