using System;
using CBXInputBindings;
using Microsoft.Xna.Framework;
using Ohsai;

namespace Ohsai_TestProject.Sensors
{
    public struct GamePadSensorResult
    {
        public PlayerIndex Player;
        public string Action;
        public float Value;
    }

    public class GamePadSensor : BaseSensor, IObjectBinder
    {
        public string Action { get; set; }
        private PlayerIndex Player { get; set; }
                                

        public GamePadSensor(string action, PlayerIndex player)
        {
            this.Action = action;
            this.Player = player;
        }

        public void HandleAction(object sender, ActionArgs e)
        {
            this.Results.Clear();
            if (e.Name == this.Action & e.Player == (int)this.Player && e.Value != 0)
            {
                var result = new GamePadSensorResult();
                result.Action = e.Name;
                result.Value = e.Value;
                result.Player = (PlayerIndex)Enum.Parse(typeof(PlayerIndex), e.Player.ToString());

                this.Results.Add(result);
            }
        }
    }
}