﻿using System.Collections.Generic;
#if XNA
using VectorType = Microsoft.Xna.Framework.Vector3;
#endif
namespace Ohsai
{
    [OhsaiAgent( "BasicAgent",  "Provides a basic implementation of th IAgent interface.")]
    public class BasicAgent : IAgent       ,IQueryable
    {
        [OhsaiReader("Ohsai.ReadersWriters.VectorTypeReader")]
        [OhsaiWriter("Ohsai.ReadersWriters.VectorTypeWriter")]
        [OhsaiProperty("Position", "Gets or sets the position of the agent.")]
        public virtual VectorType Position { get; set; }
        [OhsaiReader("Ohsai.ReadersWriters.VectorTypeReader")]
        [OhsaiWriter("Ohsai.ReadersWriters.VectorTypeWriter")]
        [OhsaiProperty("Direction", "Gets or sets the direction of the agent.")]
        public virtual VectorType Direction { get; set; }
        public List<IResponder> Responders { get; set; }
        public IWorldQuery WorldQuery { get; set; }

        public BasicAgent()
        {
            this.Responders=new List<IResponder>();
        }
    }
}
