﻿using System.Collections.Generic;
using Microsoft.Xna.Framework;

namespace Ohsai
{
    public class Manager : GameComponent
    {
        public virtual List<IAgent> Actors { get; set; }
        private readonly TimeEventArgs timeArgs = new TimeEventArgs();


        public Manager(Game game)
            : base(game)
        {
            this.Actors = new List<IAgent>();
        }

        public override void Update(GameTime gameTime)
        {
            this.timeArgs.Time = gameTime.TotalGameTime;

            foreach (var actor in this.Actors)
                foreach (var responder in actor.Responders)
                    responder.Update(this, this.timeArgs);
        }
    }
}
