
namespace Ohsai.SensorFilters
{
    [OhsaiSensorFilter("TypeFilter", "Provides a filter that filters out specific object types.", null)]
    public class TypeFilter : ISensorFilter
    {
        [OhsaiProperty("Type", "Gets or sets a value to compare against.")]
        public string Type { get; set; }


        public void Filter(ISensor sensor)
        {
            if (sensor == null) return;
            if (sensor.Results == null || sensor.Results.Count == 0) return;

            int index = 0;
            while (index < sensor.Results.Count)
            {
                var result = sensor.Results[index];
                if (result.GetType().FullName != this.Type)
                {
                    sensor.Results.RemoveAt(index);
                }
                else
                {
                    index++;
                }
            }
        }
    }
}