﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ohsai.Sensors
{
    [OhsaiSensor("BumpSensor", "Provides a sensor for detecting collisions.")]
    public class BumpSensor : BaseSensor
    {
        [OhsaiAgentProperty( "Owner",  "Gets or sets the agent that this verb will affect.")]
        public virtual IAgent Owner { get; set; }
        [OhsaiProperty( "CollisionRadius",  "Gets or sets the collision radius used to determin if a collision has occoured.")]
        public float CollisionRadius { get; set; }


        public override void Update(object sender, EventArgs e)
        {
            var objs = this.Owner.WorldQuery.GetObjects(this.Owner.Position, this.CollisionRadius);
            this.Results.Clear();
            this.Results.AddRange(objs);
        }
    }
}
