using System;
using Microsoft.Xna.Framework;

namespace Ohsai.Sensors
{
    [Ohsai.OhsaiSensor("Proximity", "Provides a sensor for proximity detection.")]
    public class Proximity : BaseSensor
    {
        [OhsaiAgentProperty("Owner", "Gets or sets the agent that this verb will affect.")]
        public virtual IAgent Owner { get; set; }
        [OhsaiProperty("Distance", "Gets or sets the proximity distance.")]
        public virtual float Distance { get; set; }


        public Proximity()
        {
        }

        public override void Update(object sender, EventArgs e)
        {
            var objs = this.Owner.WorldQuery.GetObjects(this.Owner.Position, this.Distance);
            this.Results.Clear();
            this.Results.AddRange(objs);
        }
    }
}