using System;
#if XNA
using VectorType = Microsoft.Xna.Framework.Vector3;
#endif
#if SILVERLIGHT
#endif

namespace Ohsai.Sensors
{
    [Ohsai.OhsaiSensor("See", "Provides a sensor for visual sight.")]
    public class See : BaseSensor
    {
        [OhsaiAgentProperty("Owner", "Gets or sets the agent that this verb will affect.")]
        public virtual IAgent Owner { get; set; }
        [OhsaiProperty("Distance", "Gets or sets the view distance.")]
        public virtual float Distance { get; set; }
        [OhsaiProperty("FieldOfView", "Gets or sets the field of view in degrees.")]
        public virtual float FieldOfView { get; set; }
        [OhsaiReader("Ohsai.ReadersWriters.VectorTypeReader")]
        [OhsaiWriter("Ohsai.ReadersWriters.VectorTypeWriter")]
        [OhsaiProperty("Direction", "Gets or sets the direction.")]
        public virtual VectorType Direction { get; set; }


        public See()
        {
        }

        public override void Update(object sender, EventArgs e)
        {
            var objs = this.Owner.WorldQuery.GetObjects(this.Owner.Position, this.Distance, this.FieldOfView, this.Owner.Direction + this.Direction);
            this.Results.Clear();
            this.Results.AddRange(objs);
        }
    }
}