﻿using EventArgsType = System.EventArgs;

namespace Ohsai.VerbModifiers
{
    [OhsaiModifier("MoveModifier", "Moves a move on a agent that implements the IAgent interface.",
                    new[] { "Ohsai.Verbs.Move" })]
    public class MoveModifier : IModifier
    {
        [OhsaiProperty("Distance", "Gets or sets the distance to move.")]
        public float Distance { get; set; }
        [OhsaiProperty("NormalizeDirection", "Gets or sets weather the direction will be normalized before applying the distance value.")]
        public bool NormalizeDirection { get; set; }


        public MoveModifier()
        {

        }

        public virtual void Update(object sender, EventArgsType e)
        {
        }

        public virtual ModifierResult Apply(IVerb verb)
        {
            if (verb is Verbs.Move)
            {
                var move = verb as Verbs.Move;
                var dir = move.Direction;
                if (this.NormalizeDirection) dir.Normalize();
                move.Position += dir * this.Distance;
            }

            return ModifierResult.Continue;
        }
    }
}
