using System;

namespace Ohsai.VerbModifiers
{
    [OhsaiModifier( "RandomDirection",  "Provides a modifier type for pointing in a random direction.",
         new[] { "Ohsai.Verbs.Move" })]
    public class RandomDirection : RotateModifier
    {
        [OhsaiProperty( "Minimum",  "Gets or sets a minimum rotation angle in degrees.")]
        public int Minimum { get; set; }
        [OhsaiProperty( "Maximum",  "Gets or sets a maximum rotation angle in degrees.")]
        public int Maximum { get; set; }


        public RandomDirection()
        {
            this.Minimum = 0;
            this.Maximum = 359;
        }

        public override void Update(object sender, EventArgs e)
        {
            var rnd = new Random((int)DateTime.Now.Ticks);
            this.Rotation = rnd.Next(this.Minimum, this.Maximum);
        }
    }
}