using System;
#if XNA
using VectorType = Microsoft.Xna.Framework.Vector3;
#endif

namespace Ohsai.Verbs
{
    [OhsaiVerb( "Move",  "Moves a agent that implements the IAgent interface.")]
    public class Move : BaseVerb
    {
        [OhsaiAgentProperty( "Owner",  "Gets or sets the agent that this verb will affect.")]
        public virtual IAgent Owner { get;  set; }

        [OhsaiReader("Ohsai.ReadersWriters.VectorTypeReader")]
        [OhsaiWriter( "Ohsai.ReadersWriters.VectorTypeWriter")]
        [OhsaiProperty( "Position",  "Gets or sets the position of the agent.")]
        public VectorType Position
        {
            get { return this.Owner.Position; }
            set { this.Owner.Position = value; }
        }

        [OhsaiReader( "Ohsai.ReadersWriters.VectorTypeReader")]
        [OhsaiWriter( "Ohsai.ReadersWriters.VectorTypeWriter")]
        [OhsaiProperty( "Direction",  "Gets or sets the direction of the agent.")]
        public VectorType Direction
        {
            get { return this.Owner.Direction; }
            set { this.Owner.Direction = value; }
        }

        public Move()
        {
            
        }

        public Move(IAgent owner)
        {
            if (owner == null) throw new ArgumentNullException("owner");
            this.Owner = owner;
        }
    }
}
